#include <iostream>
#include "binnode.h"

using namespace std;

int max(int i1, int i2) {
	return i1>i2?i1:i2;
}

template <class Elem>
int returnHeight(BinNode<Elem>* node) {
	if (node == NULL) return 0;
	return 1 + max(returnHeight(node->left()) , returnHeight(node->right()));
  }

template <class Elem>
int numberOfNodes(BinNode<Elem>* node) {
	if (node == NULL) return 0;
	return 1 + numberOfNodes(node->left()) + numberOfNodes(node->right());
}

template <class Elem>
int numberOfLeaves(BinNode<Elem>* node) {
	if (node == NULL) return 0;
	if (node->left() == NULL && node->right() == NULL) return 1;
	return numberOfLeaves(node->left()) + numberOfLeaves(node->right());
}

void main() {
	//			   		1
	//		lvl 0	    root
	//		       2  /      \   3
	//		lvl 1  	o          o
	//			   	         /   \
	//		lvl 2		 4 o       o 5
	//			   				 /
	//		lvl 3			 6 o
	//			   				 \  7
	//		lvl 4				   o

 

	/*1*/ BinNodePtr<int>* root = new BinNodePtr<int>(10);
	/*2*/ root->setLeft(new BinNodePtr<int>(15));
	/*3*/ root->setRight(new BinNodePtr<int>(20));
	/*4*/ root->right()->setLeft(new BinNodePtr<int>(15));
	/*5*/ root->right()->setRight(new BinNodePtr<int>(20));
	/*6*/ root->right()->right()->setLeft(new BinNodePtr<int>(15));
	/*7*/ root->right()->right()->left()->setRight(new BinNodePtr<int>(20));
	//int maxheight;
	//returnHeight(root,1,maxheight);
	cout<<"Height of Tree= "<<returnHeight(root); // 5
	cout<<"\nNumber of Nodes= "<<numberOfNodes(root); // 7 
	cout<<"\nNumber of Leaves= "<<numberOfLeaves(root); // 3 
	cout<<endl;
}




