#include <iostream.h>
#include <stdlib.h>
//#include "book.h"

#include "binnode.h"

// Stick these in to test the preorder routine
template <class Elem>
void visit(const Elem& X) {cout << X->val() << " ";};

template <class Elem>
void inorder(BinNode<Elem>* subroot) {
  if (subroot == NULL) return;  // Empty subtree, do nothing
  inorder(subroot->left());
  visit(subroot);  // Perform whatever action is desired
  inorder(subroot->right());
}



// Test the preorder traversal routines
int main()
{
	//			   		
	//		lvl 0	     101
	//		           /     \   
	//		lvl 1   201       202
	//			   	         /   \
	//		lvl 2		 301      302 
	//			   		/		 /   \
	//		lvl 3	401		  402     403
	//			   				 
	//		=> inorder: 201 > 101 > 401 > 301 > 202 > 402 > 302 > 403			  


  BinNodePtr<int>* root = new BinNodePtr<int>(101);
  root->setLeft(new BinNodePtr<int>(201));
  root->setRight(new BinNodePtr<int>(202));
  root->right()->setLeft(new BinNodePtr<int>(301));
  root->right()->setRight(new BinNodePtr<int>(302));
  root->right()->left()->setLeft(new BinNodePtr<int>(401));
  root->right()->right()->setLeft(new BinNodePtr<int>(402));
  root->right()->right()->setRight(new BinNodePtr<int>(403));
  inorder(root);
  cout<<endl;
  return 1;
 }
