// This is the file to include in your code if you want access to the
// complete LQueue template class

// Include the link class
#include "bnlink.h"

// First, get the declaration for the base stack class
#include "bnlqueue.h"

// Linked queue implementation
template <class Elem> class LQueue: public Queue<Elem> {
private:
  Link* front;     // Pointer to front queue node
  Link* rear;      // Pointer to rear queue node
  int size;              // Number of elements in queue
public:
  LQueue(int sz)  // Constructor 
    { front = NULL;  rear = NULL; size = 0; }
  ~LQueue() { clear(); } // Destructor
  void clear() {         // Clear queue
    while(front != NULL) { // Delete each link node
      rear = front;
      front = front->next;
      delete rear;
    }
    rear = NULL;
    size = 0;
  }
  bool enqueue(BinNode<int>& it) {
    if (rear == NULL)   // Empty queue
      front = rear = new Link(&it, NULL);
    else {              // Append new node
      rear->next = new Link(&it, NULL);
      rear = rear->next;
    }
    size++;
    return true;
  }
  bool dequeue(BinNode<int>& it) { // Remove Elem from front
    if (size == 0) return false;    // Empty
    //it = front->element;            // Store dequeued value
	cout<<front->element->val()<<" ";
	BinNode<int>* bn = front->element->left();
	if (bn != NULL) enqueue(*bn);
	bn = front->element->right();
	if (bn != NULL) enqueue(*bn);
    Link* ltemp = front;      // Hold dequeued link
    front = front->next;            // Advance front
    delete ltemp;                   // Delete link
    if (front == NULL) rear = NULL; // Dequeued last element
    size --;
	dequeue(*bn);
    return true;                    // Return element value
  }
  bool frontValue(BinNode<int>& it) const {
    if (size == 0) return false;
    //it = front->element;
    return true;
  }
  virtual int length() const { return size; }
};
