#include <iostream>
#include "binnode.h"
//#include "BinaryNodeLinkedQueue.H"
#include "aqueue.h"

using namespace std;

template <class Elem>
void visit(const Elem& X) {cout << X->val() << " ";};


template <class Elem>
void printByLevel(BinNode<Elem>* subroot) {
    AQueue<BinNode<Elem>*> q(999);
    q.enqueue(subroot);
    while (q.length()!=0) {
		BinNode<Elem>* extracted;
		q.dequeue(extracted);
		visit(extracted);
        if(extracted->left() != NULL) q.enqueue(extracted->left());
        if(extracted->right()!= NULL) q.enqueue(extracted->right());
    }
}


void main()
{
	//			   		
	//		lvl 0	     101
	//		           /     \   
	//		lvl 1   201       202
	//			   	         /   \
	//		lvl 2		 301      302 
	//			   		/		 /   \
	//		lvl 3	401		  402     403
	//			   				 
	//		=> print by level: 101 > 201 > 202 > 301 > 302 > 401 > 402 > 403			  


  BinNodePtr<int>* root = new BinNodePtr<int>(101);
  root->setLeft(new BinNodePtr<int>(201));
  root->setRight(new BinNodePtr<int>(202));
  root->right()->setLeft(new BinNodePtr<int>(301));
  root->right()->setRight(new BinNodePtr<int>(302));
  root->right()->left()->setLeft(new BinNodePtr<int>(401));
  root->right()->right()->setLeft(new BinNodePtr<int>(402));
  root->right()->right()->setRight(new BinNodePtr<int>(403));
  printByLevel(root);
  cout<<endl;
}












 

