#include <iostream.h>
#include <stdlib.h>
//#include "book.h"

#include "binnode.h"
#include "AQUEUE.h"

// Stick these in to test the preorder routine
template <class Elem>
void visit(const Elem& X) {cout << X->val() << endl;}

template <class Elem>
void inorder(BinNode<Elem>* subroot) {
  if (subroot == NULL) return;  // Empty subtree, do nothing
  inorder(subroot->left());
  visit(subroot);  // Perform whatever action is desired
  inorder(subroot->right());
}

int max(int x,int y)
{
        if(x>y) return x;
        else return y;
}


template <class Elem>
int height(BinNode<Elem>* subroot)
{
        if(subroot == NULL) return 0;
        return 1+max(height(subroot->left()),height(subroot->right()));
}

template <class Elem>
int count(BinNode<Elem>* subroot)
{
        if(subroot == NULL) return 0;
        return 1+ count(subroot->left()) + count(subroot->right());
}

template <class Elem>
int numLeaf(BinNode<Elem>* subroot)
{
        if(subroot == NULL) return 0;
        if(subroot->isLeaf() == true ) return 1;
        else return numLeaf(subroot->left()) + numLeaf(subroot->right());
}

template <class Elem>
void level(BinNode<Elem>* subroot)
{
        AQueue<BinNode<Elem>*> q(999);
        q.enqueue(subroot);
        while(q.length()!=0)
        {
                BinNode<Elem>* temp;
                q.dequeue(temp);
                visit(temp);

            if(temp->left() != NULL) q.enqueue(temp->left());
            if(temp->right()!= NULL) q.enqueue(temp->right());

        }
}


// Test the preorder traversal routines
int main()
{
  BinNodePtr<int>* root = new BinNodePtr<int>(10);
  root->setLeft(new BinNodePtr<int>(15));
  root->setRight(new BinNodePtr<int>(20));

  cout<<"Height is :"<<height(root)<<endl;

  cout<<"Count is :"<<count(root)<<endl;

  cout<<"Number of leafs :"<<numLeaf(root)<<endl;

  cout<<"Inorder traversal:"<<endl;
  inorder(root);
  cout<<endl;

  cout<<"Level printing:"<<endl;
  level(root);
  cout<<endl;

  return 1;
 }
